""" Assign the colors to the tqgs """
# import statements
from cropping.models import Category, Colors


# the list of tags contains atm 118 categories
def assign_colors_to_tags(list_of_tags):
    """" function to assign the colors to the tags """

    list_of_colors = ['#00FFFF', '#F0FFFF', '#89CFF0', '#0000FF', '#7393B3', '#088F8F', '#0096FF', '#5F9EA0', '#0047AB',
                      # 9
                      '#6495ED', '#00FFFF', '#00008B', '#6F8FAF', '#1434A4', '#7DF9FF', '#6082B6', '#00A36C', '#3F00FF',
                      # 18
                      '#5D3FD3', '#ADD8E6', '#191970', '#000080', '#1F51FF', '#A7C7E7', '#CCCCFF', '#B6D0E2', '#96DED1',
                      # 27
                      '#4169E1', '#0F52BA', '#9FE2BF', '#87CEEB', '#4682B4', '#008080', '#40E0D0', '#0437F2', '#40B5AD',
                      # 36
                      '#0818A8', '#7FFFD4', '#454B1B', '#088F8F', '#AAFF00', '#097969', '#AFE1AF', '#DFFF00', '#E4D00A',
                      # 45
                      '#023020', '#50C878', '#5F8575', '#4F7942', '#228B22', '#7CFC00', '#008000', '#355E3B', '#00A36C',
                      # 54
                      '#2AAA8A', '#4CBB17', '#90EE90', '#32CD32', '#478778', '#0BDA51', '#98FB98', '#8A9A5B', '#0FFF50',
                      # 63
                      '#ECFFDC', '#808000', '#C1E1C1', '#C9CC3F', '#B4C424', '#93C572', '#96DED1', '#8A9A5B', '#2E8B57',
                      # 72
                      '#9FE2BF', '#009E60', '#00FF7F', '#008080', '#C4B454', '#40B5AD', '#40826D', '#9F2B68', '#BF40BF',
                      # 81
                      '#800020', '#702963', '#AA336A', '#301934', '#483248', '#5D3FD3', '#E6E6FA', '#CBC3E3', '#CF9FFF',
                      # 90
                      '#AA98A9', '#E0B0FF', '#915F6D', '#770737', '#DA70D6', '#C3B1E1', '#CCCCFF', '#673147', '#A95C68',
                      # 99
                      '#800080', '#51414F', '#953553', '#D8BFD8', '#630330', '#7F00FF', '#722F37', '#BDB5D5', '#FFC0CB',
                      # 108
                      '#FFB6C1', '#FF69B4', '#FF1493', '#DB7093', '#C71585', '#FFA07A', '#FA8072', '#E9967A', '#F08080',
                      # 117
                      '#CD5C5C']  # 118

    # the faculties should have the colors that are defined in the Printmedien-Leitfaden

    tag_id_categories = []
    for cat_id in Category.objects.all():
        tag_id_categories.append(cat_id.id)

    for category in list_of_tags:
        Colors.objects.update_or_create(colour=list_of_colors[list_of_tags.index(category)],
                                        tag_id=tag_id_categories[list_of_tags.index(category)])

        if category == 'Juristische Fakultät':
            # category.color = '#e4003a'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#e4003a', tag_id=tag_id_categories[list_of_tags.index(category)])

        elif category == 'Philosophische Fakultät':
            # category.color = '#8b2939'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#8b2939', tag_id=tag_id_categories[list_of_tags.index(category)])

        elif category == 'Humanwissenschaftliche Fakultät':
            # category.color = '#f59c00'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#f59c00', tag_id=tag_id_categories[list_of_tags.index(category)])

        elif category == 'Wirtschafts- und Sozialwissenschaftliche Fakultät':
            # category.color = '#52822f'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#52822f', tag_id=tag_id_categories[list_of_tags.index(category)])

        elif category == 'Mathematisch-Naturwissenschaftliche Fakultät':
            # category.color = '#0080b5'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#0080b5', tag_id=tag_id_categories[list_of_tags.index(category)])

        elif category == 'Digital Engineering Fakultät':
            # category.color = '#5A5F62'
            Colors.objects.filter(tag_id=tag_id_categories[list_of_tags.index(category)]).delete()
            Colors.objects.update_or_create(colour='#5A5F62', tag_id=tag_id_categories[list_of_tags.index(category)])
